﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using Infragistics.Web.UI.GridControls;

namespace Sample_Infragistics_Grid
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            if (!Page.IsPostBack)
            {
                UnboundField ub;

                ub = new UnboundField();
                ub.Key = "Dept";
                ub.Header.Text = "Dept";
                ub.Width = Unit.Pixel(100);
                Grid1.Columns.Add(ub);

                ub = new UnboundField();
                ub.Key = "First";
                ub.Header.Text = "FirstName";
                ub.Width = Unit.Pixel(100);
                Grid1.Columns.Add(ub);

                ub = new UnboundField();
                ub.Key = "Last";
                ub.Header.Text = "LastName";
                ub.Width = Unit.Pixel(100);
                Grid1.Columns.Add(ub);
                Grid1.DataKeyFields = "Dept,First";
            }

            Grid1.DataSource = Getperson();
            Grid1.DataBind();
        }

        public List<Person> Getperson()
        {
            List<Person> per = new List<Person>();
            per.Add(new Person { Name = new Name { FirstName = "First11", LastName = "Last11" }, Dept = 11 });
            per.Add(new Person { Name = new Name { FirstName = "Firs21", LastName = "Last21" }, Dept = 12 });
            per.Add(new Person { Name = new Name { FirstName = "First31", LastName = "Last31" }, Dept = 13 });
            per.Add(new Person { Name = new Name { FirstName = "First41", LastName = "Last41" }, Dept = 14 });
            per.Add(new Person { Name = new Name { FirstName = "First51", LastName = "Last51" }, Dept = 15 });
            return per;
        }

        protected void Grid1_InitializeRow(object sender, RowEventArgs e)
        {
            Person provider = new Person();
            provider = (Person)e.Row.DataItem;
            e.Row.Items.FindItemByKey("Dept").Text = provider.Dept.ToString();
            e.Row.Items.FindItemByKey("First").Text = provider.Name.FirstName;
            e.Row.Items.FindItemByKey("Last").Text = provider.Name.LastName;

        }
    }

    public class Person
    {

        public Name Name { get; set; }

        public int Dept { get; set; }
    }



    public class Name
    {

        public string FirstName { get; set; }

        public string LastName { get; set; }

    }
}